<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\platform_rule;


use app\common\model\platform_rule\PlatformRule;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * PlatformRule逻辑
 * Class PlatformRuleLogic
 * @package app\adminapi\logic\platform_rule
 */
class PlatformRuleLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/11 11:41
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            PlatformRule::create([
                'rule_name' => $params['rule_name'],
                'description' => $params['description'],
                'sort' => $params['sort']
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/11 11:41
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            PlatformRule::where('id', $params['id'])->update([
                'rule_name' => $params['rule_name'],
                'description' => $params['description'],
                'sort' => $params['sort']
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/11 11:41
     */
    public static function delete(array $params): bool
    {
        return PlatformRule::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2024/07/11 11:41
     */
    public static function detail($params): array
    {
        return PlatformRule::findOrEmpty($params['id'])->toArray();
    }
}